Option Strict Off
Option Explicit On
Imports System
Imports System.Windows.Forms
Imports System.Runtime.InteropServices

Imports Application = Intergraph.GeoMedia.GeoMedia.Application
Imports GMViewListeners = Intergraph.GeoMedia.PCmdMgr.GMViewListeners
Imports MapWindow = Intergraph.GeoMedia.GeoMedia.MapWindow
Imports GMMapView = Intergraph.GeoMedia.MapviewLib.GMMapView
Imports Windows = Intergraph.GeoMedia.GeoMedia.Windows
<System.Runtime.InteropServices.ProgId("GeoMediaCommand.Incidencias")> Public Class Incidencias


    'Private mobjGeoApp As Object
    Private mobjGeoViewListeners As GMViewListeners

    'WIZARD: Modeless
    'Private mbImDone As Boolean
    'ENDWIZARD
    'WIZARD: MapViewListener
    'Dim MyMapWindows As New ArrayList()
    'Private MyEventServerObject As Object

    'ENDWIZARD
    Dim frmIncidencias As New frmIncidencias

    ReadOnly Property IsDone() As Boolean
        Get
            'WIZARD: Modeless
            ''Modeless commands must manage the IsDone property so the command manager
            ''will know whether or not your modeless command is still actively listening
            ''at some window.
            'IsDone = mbImDone
            'ENDWIZARD
        End Get
    End Property


#Region "Initialize"
    Sub Initialize(ByVal objApplication As Object, ByVal objViewListeners As Object)
        'The Initialize method is called once per command server creation.

        'Save the pointer to the Application object and the View Listeners object.
        'The application object is the top of application's automation model.
        '    Set gobjGeoApp = objApplication
        gobjGeoApp = objApplication
        mobjGeoViewListeners = objViewListeners

        'WIZARD: MapViewListener
        'mobjGeoViewListeners.Add(Nothing, Me)
        'MyEventServerObject = objApplication.CreateService("GeoMedia.EventServer")
        'ENDWIZARD

        'WIZARD: Modeless
        ''Modeless commands must manage the IsDone property so the command manager
        ''will know whether or not your modeless command is still actively listening
        ''at some window.
        'mbImDone = True
        'ENDWIZARD

        'WIZARD: HasForm
        ''Show the command's GUI on each activation.
        ''Load frmIncidencias
        'ENDWIZARD

    End Sub
#End Region

#Region "Activate"
    Sub Activate()
        'WIZARD: MapViewListener
        'Dim mbNewActivation As Boolean = mbImDone        
        'ENDWIZARD

        'WIZARD: Modeless
        ''Modeless commands must set the IsDone property to False for each Activate.
        ''The IsDone property should be set to True when the command is finished or
        ''whenever the Deactivate method is called.
        'mbImDone = False
        'ENDWIZARD

        'WIZARD: ModalWithForm
        'Show the command's GUI on each activation.

        'WIZARD: CenterOnApp
        'frmIncidencias.StartPosition = FormStartPosition.CenterParent 
        'ENDWIZARD

        'WIZARD: CenterOnScreen
        frmIncidencias.StartPosition = FormStartPosition.CenterScreen
        'ENDWIZARD

         frmIncidencias.ShowDialog()
        'ENDWIZARD

        'WIZARD: MapViewListener
        ''Register this command with the view listeners manager.
        ''Get a pointer to the active map view
        'Dim objwnds As Windows = Nothing
        'Dim objMapView as GMMapView = Nothing
        'Dim I As Integer
        'Try
        'If mbNewActivation then
        'objwnds = gobjGeoApp.Windows 
        'For I = 1 To objwnds.Count
        'If objwnds.Item(I).Type = "MapWindow" Then
        'mobjGeoViewListeners.Add(objwnds.Item(I), Me)

        ''Connect to the Map View through the event control.
        'objMapView = objwnds.Item(I).MapView
        'frmIncidencias.EventControl1.AddMapView( objMapView, MyEventServerObject )

        ''Add this to my private collection of attached view windows
        'MyMapWindows.Add (objwnds.Item( i ))
        'End If

        'Next
        'else
        ''Command is already active, just manage collisions
        'For I = 1 To MyMapWindows.Count
        ''Try to add the view through the view listeners manager.
        ''It is the attempt to add which causes the other conflicting
        ''map view listener commands to either be removed or forced to
        ''ignore events.
        'mobjGeoViewListeners.Add (MyMapWindows(I), Me)

        'Next
        'End if
        'Catch
        'Finally

        'If (objwnds IsNot Nothing) Then
        'Marshal.ReleaseComObject( objwnds )
        'End If
        'If (objMapView IsNot Nothing) Then
        'Marshal.ReleaseComObject( objMapView )
        'End If
        'End Try
        'ENDWIZARD

        'NOTE TO COMMAND WRITER:  Insert your activation code here.

        'WIZARD: Modeless
        ''If your code self-terminates during processing, be sure to call
        ''Deactivate on yourself or do the equivalent clean-up.
        'ENDWIZARD


    End Sub
#End Region

#Region "CanDeactivate"



#End Region

#Region "CanEnable"



#End Region

#Region "CanActivate"



#End Region

#Region "Deactivate"



#End Region

#Region "AddView"



#End Region

#Region "RemoveView"


#End Region

#Region "IgnoreEvents"



#End Region

#Region "RestoreEvents"



#End Region

#Region "Terminate"

    Sub Terminate()
        If (gobjGeoApp IsNot Nothing) Then
            Marshal.ReleaseComObject(gobjGeoApp)
        End If
        'Perform any shutdown cleanup activities before we are released.
        ' let go local copies of application ptr and ViewListeners ptr        


        'WIZARD: MapViewListener
        'mobjGeoViewListeners.Remove(Nothing, Me)
        'If (MyEventServerObject IsNot Nothing) Then
        'Marshal.ReleaseComObject(MyEventServerObject)
        'End If
        'If (MyMapWindows.Count <> 0) Then
        'Deactivate()
        'End If
        'ENDWIZARD
        If (mobjGeoViewListeners IsNot Nothing) Then
            Marshal.ReleaseComObject(mobjGeoViewListeners)
        End If

        'WIZARD: HasForm
        ''Show the command's GUI on each activation.
        '   frmIncidencias.Close()
        'ENDWIZARD
        GC.Collect()
        GC.WaitForPendingFinalizers()

    End Sub
#End Region

#Region "Help"



#End Region

#Region "NotifyStartModal"



#End Region

#Region "NotifyEndModal"



#End Region
End Class














