Imports GeoMedia = Intergraph.GeoMedia.GeoMedia
Imports Windows = Intergraph.GeoMedia.GeoMedia.Windows
Imports PClient = Intergraph.GeoMedia.PClient
Imports PBasic = Intergraph.GeoMedia.PBasic
Imports PView = Intergraph.GeoMedia.PView
Imports MapWindow = Intergraph.GeoMedia.GeoMedia.MapWindow
Imports GMMapView = Intergraph.GeoMedia.MapviewLib.GMMapView
Imports GDO = Intergraph.GeoMedia.GDO
Imports PCSS = Intergraph.GeoMedia.PCSS
Imports PDBPipe = Intergraph.GeoMedia.PDBPipe

Public Class FormCrear

    'VARIABLES
    Dim oConn As PClient.Connection
    Dim objCrearRS As GDO.GRecordset, objOP As PClient.OriginatingPipe


    Private Sub FormCrear_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load


        'Conexin a la base de datos de incidencias, tabla incidencias
        oConn = gobjGeoApp.Document.Connections(2)
        oConn.CreateOriginatingPipe(objOP)
        objOP.Table = "INCIDENCIAS"
        objCrearRS = objOP.OutputRecordset
        objOP = Nothing

        'Guardamos los valores iniciales
        If objCrearRS.Updatable Then
            objCrearRS.AddNew()
            objCrearRS.GFields("ESTADO").Value = "abierta"
            objCrearRS.GFields("FECHAINICIO").Value = DateTime.Now
            objCrearRS.GFields("NINTERNO").Value = o
        Else
            MsgBox("Error creando incidencia")
        End If

        BtnCrear.Enabled = False

    End Sub

    'Guarda el motivo de la incidencia
    Private Sub TextBox1_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox1.TextChanged
        If TextBox1.Text <> "" Then
            BtnCrear.Enabled = True
        Else
            BtnCrear.Enabled = False
        End If
        objCrearRS.GFields("MOTIVO").Value = TextBox1.Text
    End Sub


    'Toma la hora de inicio de la incidencia
    Private Sub DateTimePicker1_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DateTimePicker1.ValueChanged
        objCrearRS.GFields("FECHAINICIO").Value = DateTimePicker1.Value
    End Sub


    'Guarda la descripcin de la incidencia
    Private Sub TextBox6_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox6.TextChanged
        objCrearRS.GFields("DESCRIPCION").Value = TextBox6.Text
        If TextBox6.Text <> "" Then
            BtnCrear.Enabled = True
        Else
            BtnCrear.Enabled = False
        End If
    End Sub


    'Guarda el valor del radio de afectacin
    Private Sub TextBoxRadio_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxRadio.TextChanged
        objCrearRS.GFields("RADIO").Value = TextBoxRadio.Text
    End Sub


    'Salir del formulario
    Private Sub BtnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnCancel.Click
        objCrearRS = Nothing
        Me.Close()
    End Sub


    'Guarda la incidencia creada
    Private Sub BtnCrear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnCrear.Click
        objCrearRS.Update()
        objCrearRS = Nothing
        Me.Close()
    End Sub


End Class