Imports GeoMedia = Intergraph.GeoMedia.GeoMedia
Imports Windows = Intergraph.GeoMedia.GeoMedia.Windows
Imports PClient = Intergraph.GeoMedia.PClient
Imports PBasic = Intergraph.GeoMedia.PBasic
Imports PView = Intergraph.GeoMedia.PView
Imports MapWindow = Intergraph.GeoMedia.GeoMedia.MapWindow
Imports GMMapView = Intergraph.GeoMedia.MapviewLib.GMMapView
Imports GDO = Intergraph.GeoMedia.GDO
Imports PCSS = Intergraph.GeoMedia.PCSS
Imports PPipe = Intergraph.GeoMedia.PPipe
Imports PDBPipe = Intergraph.GeoMedia.PDBPipe
Imports System.Data.OleDb


Module compartir
    Public o As Double
    Public objCrearRS As GDO.GRecordset
    Public objRS As GDO.GRecordset
End Module


<System.Runtime.InteropServices.ProgId("GeoMediaCommand.FormCrear")> Public Class frmIncidencias
    Dim GMMapView1, GMMapView2 As New GMMapView
    ' Dim objconn As New PClient.Connection
    Dim objwnds As Windows = Nothing
    Dim Selected As Object
    Dim oConn As PClient.Connection
    Dim DS As New DataSet
    Dim carga, CargaCerradas As OleDbDataAdapter
    Dim objOP As PClient.OriginatingPipe
    Dim mapWind As MapWindow
    Dim sKML As New PView.PublishToCanvasService


    Public Sub frmPrincipal_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        'Dim RutaBBDDincidencias As String = "\GestorDeIncidencias\BBDD"
        'Dim TextContent As String = IO.File.ReadAllText(RutaBBDDincidencias)
        'Dim TextReader As New IO.StringReader(TextContent)

        'Dim Archivo As New System.IO.StreamReader("pathIncidencias.txt")
        'Archivo.ReadLine()
        'MsgBox(Archivo)


        ''Buscar el mapa
        Dim I As Integer
        objwnds = gobjGeoApp.Windows
        For I = 1 To objwnds.Count
            If objwnds.Item(I).Type = "MapWindow" Then
                'Conectarse al mapa 
                GMMapView1 = objwnds.Item(I).MapView
            End If
        Next

        'Deshabilitar boton crear
        If GMMapView1.MapViewSelectedObjects.Count <> 0 Then
            BtnCrearInc.Enabled = True
        Else
            BtnCrearInc.Enabled = False
        End If

        BtnGuardarCambios.Enabled = False

        ' Selected Object es un geometryObject, guardamos NINTERNO en memoria
        If GMMapView1.MapViewSelectedObjects.Count = 1 Then
            Selected = GMMapView1.MapViewSelectedObjects.Item(1)
            objCrearRS = Selected.Recordset
            o = objCrearRS.GFields("NINTERNO").Value
        End If

        RadioBtnAbiertas.Checked = True

        'Carga el DataGridView, 
        'true= carga los datos sin filtrar por das, false: filtra por das
        CargarGrid(True)

    End Sub


    'Carga la tabla incidencias de la BBDD access Incidencias
    Public Sub CargarGrid(ByVal todos As Boolean)

        Dim IncConn As New OleDb.OleDbConnection("PROVIDER = MICROSOFT.ACE.OLEDB.12.0;DATA SOURCE = C:\GestorDeIncidencias\BBDD\Incidencias.mdb")
        Dim Fecha As DateTime = DTPickerFiltrar.Value.Date
        Dim Cmd As OleDbCommand = IncConn.CreateCommand()

        'Seleccionar incidencias con filtro o sin l
        If todos = True Then
            Cmd.CommandText = _
                       "SELECT * FROM INCIDENCIAS"
            DTPickerFiltrar.ResetText()
        Else
            Cmd.CommandText = _
                       "SELECT * FROM INCIDENCIAS WHERE FECHAINICIO >= " & DTPickerFiltrar.Value.Date.ToOADate
        End If

        IncConn.Open()

        'Llenar el datagridview
        carga = New OleDbDataAdapter(Cmd)
        Dim builder As OleDbCommandBuilder = New OleDbCommandBuilder(carga)
        DS = New DataSet()
        carga.SelectCommand.Connection = IncConn
        carga.Fill(DS, "INCIDENCIAS")
        DataGridView1.DataSource = DS.Tables("INCIDENCIAS").DefaultView

        IncConn.Close()

        'propiedades datagridview
        DataGridView1.Columns("ID").ReadOnly = True
        DataGridView1.Columns("ID").DefaultCellStyle.BackColor = Drawing.Color.LightGray
        DataGridView1.Columns("ESTADO").ReadOnly = True
        DataGridView1.Columns("ESTADO").DefaultCellStyle.BackColor = Drawing.Color.LightGray
        DataGridView1.Columns("MOTIVO").ReadOnly = False
        DataGridView1.Columns("MOTIVO").DefaultCellStyle.BackColor = Drawing.Color.Empty
        DataGridView1.Columns("RADIO").ReadOnly = False
        DataGridView1.Columns("RADIO").DefaultCellStyle.BackColor = Drawing.Color.Empty
        DataGridView1.Columns("FECHAINICIO").ReadOnly = True
        DataGridView1.Columns("FECHAINICIO").DefaultCellStyle.BackColor = Drawing.Color.Empty
        DataGridView1.Columns("FECHACIERRE").ReadOnly = True
        DataGridView1.Columns("FECHACIERRE").DefaultCellStyle.BackColor = Drawing.Color.Empty
        DataGridView1.Columns("DESCRIPCION").ReadOnly = False
        DataGridView1.Columns("DESCRIPCION").DefaultCellStyle.BackColor = Drawing.Color.Empty
        DataGridView1.Columns("NINTERNO").ReadOnly = True
        DataGridView1.Columns("NINTERNO").DefaultCellStyle.BackColor = Drawing.Color.Empty
        DataGridView1.Columns("NINTERNO").Visible = False

        IncConn = Nothing
        BtnCerrarInc.Enabled = True

    End Sub


    'Filtra y carga las incidencias cerradas de la BBDD incidencias tabla HISTORICO
    Private Sub CargarCerradas(ByVal todos As Boolean)

        Dim HistConn As New OleDb.OleDbConnection("PROVIDER = MICROSOFT.ACE.OLEDB.12.0;DATA SOURCE = C:\GestorDeIncidencias\BBDD\Incidencias.mdb")
        Dim Fecha As DateTime = DTPickerFiltrar.Value.Date
        Dim Cmd As OleDbCommand = HistConn.CreateCommand()

        'carga el datagridview on datos filtrados/la tabla entera
        If todos = True Then
            Cmd.CommandText = _
                       "SELECT * FROM HISTORICO"
            DTPickerFiltrar.ResetText()
        Else
            Cmd.CommandText = _
                       "SELECT * FROM HISTORICO WHERE FECHACIERRE >= " & DTPickerFiltrar.Value.Date.ToOADate
        End If

        HistConn.Open()

        CargaCerradas = New OleDbDataAdapter(Cmd)
        Dim builder As OleDbCommandBuilder = New OleDbCommandBuilder(carga)
        DS = New DataSet()
        CargaCerradas.SelectCommand.Connection = HistConn
        CargaCerradas.Fill(DS, "HISTORICO")
        DataGridView1.DataSource = DS.Tables("HISTORICO").DefaultView

        HistConn.Close()

        'propiedades datagridview
        DataGridView1.Columns("ID").ReadOnly = True
        DataGridView1.Columns("ID").DefaultCellStyle.BackColor = Drawing.Color.LightGray
        DataGridView1.Columns("ESTADO").ReadOnly = True
        DataGridView1.Columns("ESTADO").DefaultCellStyle.BackColor = Drawing.Color.LightGray
        DataGridView1.Columns("MOTIVO").ReadOnly = True
        DataGridView1.Columns("MOTIVO").DefaultCellStyle.BackColor = Drawing.Color.LightGray
        DataGridView1.Columns("RADIO").ReadOnly = True
        DataGridView1.Columns("RADIO").DefaultCellStyle.BackColor = Drawing.Color.LightGray
        DataGridView1.Columns("FECHAINICIO").ReadOnly = True
        DataGridView1.Columns("FECHAINICIO").DefaultCellStyle.BackColor = Drawing.Color.LightGray
        DataGridView1.Columns("FECHACIERRE").ReadOnly = True
        DataGridView1.Columns("FECHACIERRE").DefaultCellStyle.BackColor = Drawing.Color.LightGray
        DataGridView1.Columns("DESCRIPCION").ReadOnly = True
        DataGridView1.Columns("DESCRIPCION").DefaultCellStyle.BackColor = Drawing.Color.LightGray
        DataGridView1.Columns("NINTERNO").ReadOnly = True
        DataGridView1.Columns("NINTERNO").DefaultCellStyle.BackColor = Drawing.Color.LightGray

        HistConn = Nothing
        BtnCerrarInc.Enabled = False


    End Sub


    'Lanza el formulario de creacin de incidencias
    Public Sub BtnCrear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnCrearInc.Click
        'boton crear

        Dim formCrear As New FormCrear
        formCrear.ShowDialog()
        CargarGrid(True)

    End Sub


    'Cierra la incidencia seleccionada
    Public Sub BtnCerrarInc_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnCerrarInc.Click
        'boton borrar

        DataGridView1.CurrentRow.Cells(1).Value = "cerrada"
        DataGridView1.CurrentRow.Cells(4).Value = DateTime.Now

        'Conectar a la BBDD HISTORICO
        oConn = gobjGeoApp.Document.Connections(2)
        oConn.CreateOriginatingPipe(objOP)
        objOP.Table = "HISTORICO"
        objRS = objOP.OutputRecordset
        objOP = Nothing

        'Actualizar datos del recordset
        If objRS.Updatable Then
            objRS.AddNew()
            objRS.GFields("ID").Value = DataGridView1.CurrentRow.Cells(0).Value
            objRS.GFields("ESTADO").Value = DataGridView1.CurrentRow.Cells(1).Value
            objRS.GFields("MOTIVO").Value = DataGridView1.CurrentRow.Cells(2).Value
            objRS.GFields("FECHAINICIO").Value = DataGridView1.CurrentRow.Cells(3).Value
            objRS.GFields("FECHACIERRE").Value = DataGridView1.CurrentRow.Cells(4).Value
            objRS.GFields("RADIO").Value = DataGridView1.CurrentRow.Cells(5).Value
            objRS.GFields("DESCRIPCION").Value = DataGridView1.CurrentRow.Cells(6).Value
            objRS.GFields("NINTERNO").Value = DataGridView1.CurrentRow.Cells(7).Value
        Else
            MsgBox("Error actualizando datos")
        End If

        'Update a la BBDD HISTORICO
        objRS.Update()
        objRS = Nothing
        MsgBox("Incidencia cerrada")

        'Borrado de la incidencia de la tabla INCIDENCIAS con incidencias abiertas
        DataGridView1.Rows.Remove(DataGridView1.CurrentRow)
        Me.carga.Update(Me.DS.Tables("INCIDENCIAS"))


        CargarGrid(True)

    End Sub


    'Salir del comando y volver al GeoWorkSpace
    Private Sub BtnSalir_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnSalir.Click

        GMMapView1.MapViewSelectedObjects.Clear()
        Hide()
        Me.Close()
    End Sub



    'Guarda los cambios realizados en la incidencia
    Public Sub BtnGuardarCambios_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnGuardarCambios.Click
        'boton editar

        Me.Validate()
        Me.carga.Update(Me.DS.Tables("INCIDENCIAS"))
        Me.DS.AcceptChanges()
        BtnGuardarCambios.Enabled = False
        MsgBox("incidencia guardada")

        CargarGrid(True)
    End Sub


    'Guarda el motivo en caso de edicin
    Private Sub TextBoxMotivo_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxMotivo.TextChanged
        DataGridView1.CurrentRow.Cells(2).Value = TextBoxMotivo.Text
        BtnGuardarCambios.Enabled = True

    End Sub


    'Guarda la descripcin de la incidencia en caso de edicin
    Private Sub TextBoxDesc_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxDesc.TextChanged
        DataGridView1.CurrentRow.Cells(6).Value = TextBoxDesc.Text
        If DataGridView1.CurrentRow.Cells(1).Value = "abierta" Then
            BtnGuardarCambios.Enabled = True
        End If

    End Sub

    'Pasa los datos de dataGridView a los texbox para poder editar la incidencia
    Private Sub DataGridView1_CellDoubleClick(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles DataGridView1.CellDoubleClick

        TextBoxMotivo.Text = DataGridView1.CurrentRow.Cells(2).Value
        TextBoxID.Text = DataGridView1.CurrentRow.Cells(0).Value
        TextBoxFecha.Text = DataGridView1.CurrentRow.Cells(3).Value
        TextBoxDesc.Text = DataGridView1.CurrentRow.Cells(6).Value

        BtnGuardarCambios.Enabled = False

    End Sub


    'Recarga datagridView si doble click
    Private Sub RecargarGrid_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles Me.KeyPress

        CargarGrid(True)

    End Sub


    'Exporta a KML las incidencias abiertas haciendo una relacin entre las incidencias y la cartografa
    Private Sub BtnKLM_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnKLM.Click
        ' btn exportar KLM

        Dim objJoinPipePol, objJoinPipeLin, objJoinPipePunt As New PDBPipe.EquijoinPipe
        Dim oRSInner1, oRSInner2, oRSInner3, oRSInner4, oRSOutput2, oRSOutput3, oRSOutput4 As GDO.GRecordset
        Dim objPolLEG, objLinLEG, objPuntLEG As PView.LegendEntry
        Dim GMMapView2 As New GMMapView
        Dim oIncConn, oCartConn As New PClient.Connection ' CONEXIONES
        Dim oIncPipe, oPolPipe, oLinPipe, oPuntPipe As PPipe.OriginatingPipe ' Originating PIPES
        Dim sJoinFields(1, 0) As String


        'OPenDialog para guardar la ruta del archivo excel
        If SaveFileDialog1.ShowDialog = DialogResult.OK Then

            ''Conexin a BBDD Incidencias
            oCartConn = gobjGeoApp.Document.Connections(1)
            oIncConn = gobjGeoApp.Document.Connections(2)

            ' Creacin de originatingPIPES a cada tipo de entidad
            oIncConn.CreateOriginatingPipe(oIncPipe) 'INCIDENCIAS
            With oIncPipe
                .Table = "INCIDENCIAS"
                .GeometryFieldName = "geometry"
            End With
            oRSInner1 = oIncPipe.OutputRecordset
            oIncPipe = Nothing

            oCartConn.CreateOriginatingPipe(oPolPipe) 'AREAS
            oPolPipe.Table = "CONST"
            oPolPipe.GeometryFieldName = "Geometry"
            oRSInner2 = oPolPipe.OutputRecordset
            oPolPipe = Nothing

            oCartConn.CreateOriginatingPipe(oLinPipe) 'LINEAS
            oLinPipe.Table = "EJE"
            oLinPipe.GeometryFieldName = "Geometry"
            oRSInner3 = oLinPipe.OutputRecordset
            oLinPipe = Nothing

            oCartConn.CreateOriginatingPipe(oPuntPipe) 'PUNTOS
            oPuntPipe.Table = "ELEMPUN"
            oPuntPipe.GeometryFieldName = "Geometry"
            oRSInner4 = oPuntPipe.OutputRecordset
            oPuntPipe = Nothing

            ''creacin de EquijoinPipe
            objJoinPipePol = CreateObject("GeoMedia.Equijoinpipe")
            objJoinPipeLin = CreateObject("GeoMedia.Equijoinpipe")
            objJoinPipePunt = CreateObject("GeoMedia.Equijoinpipe")

            'Relacion Inner por NINTERNO 
            sJoinFields(0, 0) = "NINTERNO"
            sJoinFields(1, 0) = "NINTERNO"


            'EJECUCION DE LA RELACION INTERNA
            With objJoinPipePol        'EQUIJOIN DE AREAS
                ' el tipo default es inner join
                .JoinFieldNames = sJoinFields
                .LeftRecordset = oRSInner1
                .RightRecordset = oRSInner2
            End With
            oRSOutput2 = objJoinPipePol.OutputRecordset
            objJoinPipePol = Nothing

            With objJoinPipeLin 'EQUIJOIN DE LINEAS
                .JoinFieldNames = sJoinFields
                .LeftRecordset = oRSInner1
                .RightRecordset = oRSInner3
            End With
            oRSOutput3 = objJoinPipeLin.OutputRecordset
            objJoinPipeLin = Nothing

            With objJoinPipePunt        'EQUIJOIN DE PUNTOS
                .JoinFieldNames = sJoinFields
                .LeftRecordset = oRSInner1
                .RightRecordset = oRSInner4
            End With
            oRSOutput4 = objJoinPipePunt.OutputRecordset
            objJoinPipePunt = Nothing

            'estilo de la leyenda areas
            Dim objStylePOL As PView.StyleDefinition = Nothing
            Dim objStyleServPOL As New PView.StyleService
            objStyleServPOL.GetStyle("Area Style", objStylePOL)

            'estilo de la leyenda lineas
            Dim objStyleLIN As PView.StyleDefinition = Nothing
            Dim objStyleServLIN As New PView.StyleService
            objStyleServLIN.GetStyle("Simple Line Style", objStyleLIN)

            'estilo de la leyenda puntos
            Dim objStylePUNT As PView.StyleDefinition = Nothing
            Dim objStyleServPUNT As New PView.StyleService
            objStyleServPUNT.GetStyle("Symbol Style", objStylePUNT)

            'creamos leyenda de la relacion interna CONST con incidencias
            objPolLEG = CreateObject("Geomedia.LegendEntry")        'POL
            With objPolLEG
                .InputRecordset = oRSOutput2
                .Title = "Incidencias en Areas"
                .Style = objStylePOL
                .GeometryFieldName = "Geometry"
            End With

            'creamos leyenda de la relacion interna EJE con incidencias
            objLinLEG = CreateObject("Geomedia.LegendEntry")        'LIN
            With objLinLEG
                .InputRecordset = oRSOutput3
                .Title = "Incidencias en lineas"
                .Style = objStyleLIN
                .GeometryFieldName = "Geometry"
            End With

            'creamos leyenda de la relacion interna ELEMPUN con incidencias
            objPuntLEG = CreateObject("Geomedia.LegendEntry")        'PUNT
            With objPuntLEG
                .InputRecordset = oRSOutput4
                .Title = "Incidencias en puntos"
                .Style = objStylePUNT
                .GeometryFieldName = "Geometry"
            End With


            '*********************************************
            '   PREPARACIN DEL MAPA KML A EXPORTAR
            '*********************************************

            ' Creamos nueva ventana de mapa (2)
            mapWind = gobjGeoApp.Document.NewMapWindow()
            Dim i As Integer
            For i = 2 To objwnds.Count
                If objwnds.Item(i).Type = "MapWindow" Then
                    GMMapView2 = objwnds.Item(i).MapView
                End If
            Next

            'Creamos nueva leyenda y la aadimos a la nueva ventana de mapa
            Dim LegGMV2 = New PView.Legend
            LegGMV2 = GMMapView2.Legend

            'Creamos la propiedad GMProperty para aadir el atributo "KMLPublishAttributes" = true 
            'y as poder publicar los atributos en Google Earth. Geomedia no permite seleccionar atributos a publicar.
            Dim theProp As PDBPipe.GMProperty
            theProp = CreateObject("GeoMedia.GMProperty")
            theProp.Name = "KMLPublishAttributes"
            theProp.Value = True

            'Aadimos la propiedad "KMLPublishAttributes" a las 3 entradas de leyenda
            objPolLEG.PropertySet.Append(theProp)
            objLinLEG.PropertySet.Append(theProp)
            objPuntLEG.PropertySet.Append(theProp)

            'Creamos la propiedad GMProperty para aadir el atributo "KMLFeatureName" = true 
            'y as poner nombre a cada entidad a publicar en el archivo KML
            Dim theProp1 As PDBPipe.GMProperty
            Dim objFA As PDBPipe.FunctionalAttribute
            theProp1 = CreateObject("GeoMedia.GMProperty")
            objFA = CreateObject("GeoMedia.FunctionalAttribute")

            objFA.Expression = "MOTIVO"
            theProp1.Name = "KMLFeatureName"
            theProp1.Value = objFA

            'Aadimos la propiedad "KMLFeatureName" a las 3 entradas de leyenda
            objPolLEG.PropertySet.Append(theProp1)
            objLinLEG.PropertySet.Append(theProp1)
            objPuntLEG.PropertySet.Append(theProp1)

            'Aadimos las entradas de leyenda a la leyenda principal
            LegGMV2.LegendEntries.Append(objPolLEG)
            LegGMV2.LegendEntries.Append(objLinLEG)
            LegGMV2.LegendEntries.Append(objPuntLEG)

            'Cargamos los datos de las entradas de leyenda y ajustamos mapa
            objPolLEG.LoadData()
            objLinLEG.LoadData()
            objPuntLEG.LoadData()

            GMMapView2.Fit()


            '*********************************************
            'Exportar a KML
            '*********************************************

            Dim kmlExtension As String
            kmlExtension = ".kml"


            Dim Coord As PCSS.CoordSystem
            Coord = gobjGeoApp.Document.CoordSystemsMgr.CoordSystem
            With sKML
                .CanvasType = "kml"
                .InputCoordSystem = Coord
                .InputLegend = LegGMV2
                .OutputDataTarget = SaveFileDialog1.FileName & kmlExtension
            End With


            Try
                sKML.Execute()
                MsgBox("KML exportado correctamente")

            Catch ex As Exception
                'error.
                MsgBox("Error, KML no exportado" & ex.Message)
            End Try

        End If
    End Sub



    'Importa las incidencias de un archivo excel a la tabla INCIDENCIAS de la BBDD "incidencias.mdb" de access.
    Private Sub BtnXLS_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnXLS.Click

        'OPenDialog para guardar la ruta del archivo excel
        If OpenFileDialog1.ShowDialog = DialogResult.OK Then

            Dim Excelpath As String = OpenFileDialog1.FileName

            'Establecer rutas al archivo excel
            Dim cadenaConexionExcel As String = _
                "Provider=Microsoft.ACE.OLEDB.12.0;" & _
                "Extended Properties='Excel 12.0 Xml;HDR=Yes';" & _
                "Data Source=" & Excelpath
            Dim ExcelSheet As String = "[Hoja1$]"

            'Establecer rutas al archivo access
            Dim AccessPath As String = "C:\GestorDeIncidencias\BBDD\Incidencias.mdb"
            Dim AccessTableName As String = "INCIDENCIAS"

            Dim query As String = String.Format( _
                "INSERT INTO {0} IN '{1}' " & _
                "SELECT * FROM {2}", AccessTableName, AccessPath, ExcelSheet)

            Try
                ' Conexin al excel
                Using oExcelconn As New OleDbConnection(cadenaConexionExcel)
                    Dim cmd As OleDbCommand = oExcelconn.CreateCommand()
                    cmd.CommandText = query
                    oExcelconn.Open()

                    Dim n As Integer = cmd.ExecuteNonQuery()
                    MsgBox("Nmero de incidencias aadidas: " & CStr(n))
                    oExcelconn.Close()
                End Using

            Catch ex As Exception
                'error.
                MsgBox(ex.Message)
            End Try
        End If

    End Sub


    'Carga el DataGridView con las incidencias abierta o cerradas segn filtro
    Private Sub DTPickerFiltrar_closeup(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DTPickerFiltrar.CloseUp
        If RadioBtnCerradas.Checked Then
            CargarCerradas(False)
        Else
            CargarGrid(False)
        End If

    End Sub


    'Carga el DataGridView con las incidencias abiertas
    Private Sub RadioBtnAbiertas_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioBtnAbiertas.CheckedChanged
        CargarGrid(True)
    End Sub

    'Carga el DataGridView con las incidencias cerradas
    Private Sub RadioBtnCerradas_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioBtnCerradas.CheckedChanged
        CargarCerradas(True)
    End Sub



End Class

